
@ECHO OFF
set tmpDir=%1
set tmpFile=%2

set ifov=%3
set ofov=%4
set xc=""
set yc=""
set rad=""
set ang=0
set type=%5
set format=%6
set tmpB=%7
set vpm="black"
set vpc="black"
set bgc="black"

REM del *.tmp
set ofoc2inv=0
set ofocinv=0
set tmpA="%tmpDir%\%tmpFile%"

if not exist fichW.tmp (
"magick.exe" identify -format %%w %tmpA% >fichW.tmp
)
if not exist fichH.tmp (
"magick.exe" identify -format %%h %tmpA% >fichH.tmp
)

@ECHO OFF
FOR /F "tokens=* delims=" %%I in ('type "fichW.tmp"') do set width=%%I
FOR /F "tokens=* delims=" %%J in ('type "fichH.tmp"') do set height=%%J
if not exist fichW2.tmp (
"magick.exe" xc: -format "%%[fx:(%width%-1)/2]" info: >fichW2.tmp
)
if not exist fichH2.tmp (
"magick.exe" xc: -format "%%[fx:(%height%-1)/2]" info: >fichH2.tmp
)
FOR /F "tokens=* delims=" %%K in ('type "fichW2.tmp"') do set w2=%%K
FOR /F "tokens=* delims=" %%L in ('type "fichH2.tmp"') do set h2=%%L

REM echo %width%
REM echo %height%
REM echo %w2%
REM echo %h2%

@ECHO OFF
set rd="rd=hypot(xd,yd);"
set xcd=%w2%
set ycd=%h2%

set xcs=%xcd%
set ycs=%ycd%

set xd="xd=i-%xcd%;"
set yd="yd=j-%ycd%;"
@ECHO OFF
IF %format%=="circular" (
		if not exist dim.tmp (
			"magick.exe" convert xc: -format "%%[fx:min(%width%,%height%)]" info:>dim.tmp
		)
		FOR /F "tokens=* delims=" %%G in ('type "dim.tmp"') do set dim=%%G
		REM ECHO "PASSE CIRCULAR"
		)
IF %format%=="fullframe" (
		if not exist dim.tmp (
			"magick.exe" convert xc: -format "%%[fx:hypot(%width%,%height%)]" info:>dim.tmp
		)
		FOR /F "tokens=* delims=" %%G in ('type "dim.tmp"') do set dim=%%G
		REM ECHO "PASSE FULLFRAME"
	)


"magick.exe" convert xc: -format "%%[fx:%dim%/2]" info:>dim2.tmp
FOR /F "tokens=* delims=" %%G in ('type "dim2.tmp"') do set dim2=%%G
REM dim2=`convert xc: -format "%[fx:$dim/2]" info:`

@ECHO OFF
REM ECHO "%ofov% avant traitement"
setlocal EnableDelayedExpansion
IF  %type%=="linear" (
	if not exist ofocinv.tmp (
	"magick.exe" convert xc: -format "%%[fx:(!ofov!*pi)/(!dim!*180)]" info:>ofocinv.tmp
	)
	FOR /F "tokens=*" %%G in ('type "ofocinv.tmp"') DO SET tmp_var=%%G
	REM ECHO !tmp_var!
	set ofocinv=!tmp_var!
	REM ECHO "ofocinv :!ofocinv! avant traitement"
	set phiang="phiang=!ofocinv!*rd;"
	REM echo "phiang : !phiang! avant traitement"
	REM ECHO "PASSE LINEAR"
	)
IF  %type%=="equalarea" (
	REM #note ofoc2inv rather than ofocinv to save computations
	REM ofoc2inv=`convert xc: -format "%%[fx:2*sin(%ofov%*pi/720)/%dim%]" info:`
	if not exist ofoc2inv.tmp (
	"magick.exe" convert xc: -format "%%[fx:2*sin(!ofov!*pi/720)/!dim!]" info: > ofoc2inv.tmp
	)
	FOR /F "tokens=* delims=" %%G in ('type "ofoc2inv.tmp"') do set tmp_var=%%G
	set ofoc2inv = !tmp_var!
	set phiang="phiang=2*asin(!ofoc2inv!*rd);"
	REM ECHO "PASSE equalarea"
	)
IF  %type%=="orthographic" (
	REM ofocinv=`convert xc: -format "%[fx:2*sin($ofov*pi/360)/$dim]" info:`
	if not exist ofocinv.tmp (
	"magick.exe" convert xc: -format "%%[fx:2*sin(!ofov!*pi/360)/!dim!]" info: > ofocinv.tmp
	)
	set ofocinv = !tmp_var!
	FOR /F "tokens=* delims=" %%G in ('type "ofocinv.tmp"') do set tmp_var=%%G
	set phiang="phiang=asin(!ofocinv!*rd);"
	REM ECHO "PASSE orthographic"
	)
IF  %type%=="stereographic" (
	REM #note ofoc2inv rather than ofocinv to save computations
	REM ofoc2inv=`convert xc: -format "%[fx:2*tan($ofov*pi/720)/$dim]" info:`
	if not exist ofoc2inv.tmp (
	"magick.exe" convert xc: -format "%%[fx:(!ofov!*pi)/(!dim!*180)]" info: > ofoc2inv.tmp
	)
	FOR /F "tokens=* delims=" %%G in ('type "ofoc2inv.tmp"') do set tmp_var=%%G
	set ofoc2inv = !tmp_var!
	set phiang="phiang=2*atan(!ofoc2inv!*rd);"
	REM ECHO "PASSE stereographic"
	)
	
@ECHO OFF
REM ifoc=`convert xc: -format "%[fx:$dim/(2*tan($ifov*pi/360))]" info:`
if not exist ifoc.tmp (
"magick.exe" convert xc: -format "%%[fx:%dim%/(2*tan(%ifov%*pi/360))]" info: > ifoc.tmp
)
	FOR /F "tokens=* delims=" %%G in ('type "ifoc.tmp"') do set ifoc=%%G
set rr="rr=%ifoc%*tan(phiang);"


set xs="xs=(rd?rr/rd:0)*xd+%xcs%;"
set ys="ys=(rd?rr/rd:0)*yd+%ycs%;"
@ECHO OFF
REM ECHO %phiang% %ifov% %ifoc% %ofocinv% %ofoc2inv%

set tmpRes="%tmpB%%tmpFile%"

"magick.exe" convert %tmpA% -fx "%xd% %yd% %rd% %phiang% %rr% %xs% %ys% (rd>%dim2%)?%bgc%:u.p{xs,ys}" %tmpRes%

move %tmpA% %tmpDir%\processed